//
// tokenize.cpp : Entry point for DLL
//

#include "stdafx.h"
#include <windows.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include "tokenizer.h"

#pragma comment(lib, "tokenizer.lib")

/* Globals: */
TModuleRec *ModuleRec;
char *Source;

//Setup the Handler Instance for the tokenizer.dll
HINSTANCE tokenizelib = NULL;

//Setup the pointers for the tokenizer.dll
//Compile(TModuleRec *, bool, bool)
CompileProc Compile;
//TestRecAlignment(TModuleRec *);
VerifyProc TestRecAlignment;
//Version(void)
VersionProc Version;


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
        case DLL_THREAD_ATTACH:
        case DLL_THREAD_DETACH:
        case DLL_PROCESS_DETACH:
            break;
    }
    return TRUE;
}

char* Tokenize(char* fileIn)
{

	if (sizeof(fileIn) > MaxSourceSize)
	{
		FreeLibrary(tokenizelib);
		return "Input is greater than MaxSourceSize.\n\nPlease keep your input below 65535 chars";
	}
	Source = (char*)malloc(sizeof(fileIn));

	//Load all of the tokenizer.dll programs
	tokenizelib = LoadLibrary(TEXT("C:\\Stamp\\tokenizer.dll"));
	if(tokenizelib == NULL) {
		FreeLibrary(tokenizelib);
		return "Error loading tokenizer.dll";
	}
	
	//Map all the functions from the tokenizer.dll
	Version = (VersionProc)GetProcAddress(tokenizelib, "Version");
	if(tokenizelib==NULL){
		FreeLibrary(tokenizelib);
		return "Error while loading Version from tokenizer.dll";
	}

	Compile =(CompileProc)GetProcAddress(tokenizelib, "Compile");
	if(tokenizelib==NULL){
		FreeLibrary(tokenizelib);
		return "Error while loading Compile from tokenizer.dll";
	}

	TestRecAlignment =(VerifyProc)GetProcAddress(tokenizelib, "TestRecAlignment");
	if(tokenizelib==NULL){
		FreeLibrary(tokenizelib);
		return "Error while loading TestRecAlignment from tokenizer.dll";
	}

	/* Allocate TModuleRec */
	ModuleRec = (TModuleRec *)malloc(sizeof(TModuleRec));
	if (ModuleRec == NULL) {
		FreeLibrary(tokenizelib);
		return "Memory Allocation Error : (Allocating TModuleRec)";
	}

	/* Call TestRecAlignment and display the results of the TModuleRec fields. */
	TestRecAlignment(ModuleRec);

	/* Tokenize the code: */
	memcpy(Source, fileIn, sizeof(fileIn));

	//Set Size of Source
	ModuleRec->SourceSize = sizeof(fileIn);

	Source[ModuleRec->SourceSize] = '\0';

	Compile(ModuleRec, Source, false, true, NULL);

	/* Close Shared Library */
	FreeLibrary(tokenizelib);

	/* Check for Failure */
	if (!ModuleRec->Succeeded)
	{
		return ModuleRec->Error;
	}
	/* Succeeded! */
	return ModuleRec->PacketBuffer;
}
